<!-- 签名管理 -->
<script lang="ts" setup>
import { Delete } from '@element-plus/icons-vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
// import tableHeader from '../../notice/tableHeader.vue'
import type { queryType, signType, typeofSign } from '../tool_interface'
import addDDialog from './addDDialog.vue'
import { printJSON } from '@/utils/printUtils'
import { deleteApi, exportApi, listPageApi } from '@/api/system/tool'
import { getDictByCode } from '@/api/system/dict'
// import { exportExcel } from '@/utils/exportXlsx'
import { exportFile } from '@/utils/exportUtils'
const { proxy } = getCurrentInstance() as any
const createTime = ref()
const searchQuery = reactive<queryType>({
  signNo: '', // 编号
  signName: '', // 名称
  signDirector: '', // 负责人
  createStartTime: '',
  createEndTime: '',
  limit: 20,
  offset: 1,
  signType: '',
  ids: [],
}) // 查询参数
watch(() => createTime.value, (newVal) => {
  if (newVal) {
    searchQuery.createStartTime = newVal[0]
    searchQuery.createEndTime = newVal[1]
  }
  else {
    searchQuery.createStartTime = ''
    searchQuery.createEndTime = ''
  }
})
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref([
  { text: '签名编号', value: 'signNo', align: 'center', width: '180' },
  { text: '签名名称', value: 'signName', align: 'center', width: '150' },
  { text: '签名负责人', value: 'signDirector', align: 'center', width: '100' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '250' },
  { text: '描述', value: 'signDesc', align: 'center' },
]) // 表格
const list = ref([]) // 表格数据
const addRef = ref() // 添加/编辑/详情/组件
// 获取类型
const getType = async () => {
  const res = await getDictByCode('signType')
  searchQuery.signType = res.data.filter((item: typeofSign) => item.name === '签名')[0].value
}
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  listPageApi(searchQuery).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 编辑
const edit = (row: signType) => {
  addRef.value.initDialog({
    ...row,
    signType: searchQuery.signType,
    title: '编辑',
  })
}

// 详情
const detail = (row: signType) => {
  addRef.value.initDialog({
    ...row,
    signType: searchQuery.signType,
    title: '详情',
  })
}
// 删除
const remove = (row: signType) => {
  ElMessageBox.confirm(
    `确认删除${row.signName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteApi({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          getList()
        }
      })
    })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  createTime.value = ''
  searchQuery.createEndTime = ''
  searchQuery.createStartTime = ''
  searchQuery.signDirector = ''
  searchQuery.signName = ''
  searchQuery.signNo = ''
  getList()
}

// 新增
const add = () => {
  addRef.value.initDialog({
    signType: searchQuery.signType,
    title: '新增',
  })
}
// 表格被选中的行
const selectList = ref<signType[]>([])
// 表格多选
const multiSelect = (row: signType[]) => {
  selectList.value = row
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (selectList.value.length) {
    selectList.value.forEach((item) => {
      searchQuery.ids?.push(item.id as string)
    })
  }
  else {
    searchQuery.ids = []
  }
  exportApi(searchQuery).then((res) => {
    exportFile(res.data, '签名管理')
    loading.close()
    searchQuery.ids = []
  })
    .catch((_) => {
      loading.close()
    })
}
// 打印
function printList() {
  const selectIds = selectList.value.map((item: signType) => item.id)
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (selectIds.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '签名管理')
  }
  else if (selectIds.length > 0) {
    const printList = list.value.filter((item: signType) => selectIds.includes(item.id))
    printJSON(printList, properties, '签名管理')
  }
  else {
    ElMessage('无可打印内容')
  }
}
onMounted(() => {
  getType().then((_) => {
    getList()
  })
})
</script>

<template>
  <!-- 布局 -->
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model="searchQuery.signNo" placeholder="签名编号" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.signName" placeholder="签名名称" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.signDirector" placeholder="负责人" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="createTime"
          type="datetimerange"
          format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
          range-separator="至"
          start-placeholder="发布开始时间"
          end-placeholder="发布结束时间"
          clearable
        />
        <!-- <el-date-picker
          v-model="searchQuery.createTime" type="datetime" format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
          placeholder="发布时间"
        /> -->
      </search-item>
      <!-- <template #btns>
        <el-button class="filter-item" type="info" :icon="Delete" :style="{ marginTop: '-10px' }" @click="reset">
          重置
        </el-button>
      </template> -->
    </search-area>
    <table-container>
      <!-- 表头区域 -->
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/sys/tool/autograph/add')" icon="icon-add" title="新建" @click="add" />
        <icon-button v-if="proxy.hasPerm('/sys/tool/autograph/export')" icon="icon-export" title="导出" @click="exportExcelBtn" />
        <icon-button v-if="proxy.hasPerm('/sys/tool/autograph/print')" icon="icon-print" title="打印" @click="printList" />
      </template>
      <!-- 表格区域 -->
      <normal-table
        :data="list" :total="total" :columns="columns as any"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }" :list-loading="loadingTable"
        :is-showmulti-select="true" :is-multi="true" @change="changePage" @multiSelect="multiSelect"
      >
        <template #preColumns>
          <el-table-column label="#" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" width="130">
            <template #default="{ row }">
              <el-button v-if="proxy.hasPerm('/sys/tool/autograph/update')" size="small" type="primary" link @click="edit(row)">
                编辑
              </el-button>
              <el-button v-if="proxy.hasPerm('/sys/tool/autograph/detail')" size="small" type="primary" link @click="detail(row)">
                详情
              </el-button>
              <el-button v-if="proxy.hasPerm('/sys/tool/autograph/delete')" size="small" type="danger" link @click="remove(row)">
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
    <add-d-dialog ref="addRef" @reset-data="getList" />
  </app-container>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 180px !important;
}

:deep(.el-table__header) {
  background-color: #bbb;
}
</style>
